1.0.21.28: implement UNLOAD-SHARED-OBJECT
[sbcl.git] / tests / foreign.test.sh
1 #!/bin/sh
2
3 # tests related to foreign function interface and loading of shared
4 # libraries
5
6 # This software is part of the SBCL system. See the README file for
7 # more information.
8 #
9 # While most of SBCL is derived from the CMU CL system, the test
10 # files (like this one) were written from scratch after the fork
11 # from CMU CL.
12 #
13 # This software is in the public domain and is provided with
14 # absolutely no warranty. See the COPYING and CREDITS files for
15 # more information.
16
17 . ./subr.sh
18 use_test_subdirectory
19
20 echo //entering foreign.test.sh
21
22 # simple way to make sure we're not punting by accident:
23 # setting PUNT to anything other than 104 will make non-dlopen
24 # and non-linkage-table platforms fail this
25 PUNT=$EXIT_TEST_WIN
26
27 ## Make some shared object files to test with.
28
29 build_so() (
30   echo building $1.so
31   set +u
32   case "`uname -m`" in
33       x86_64|amd64|mips|mips64)
34           CFLAGS="$CFLAGS -fPIC"
35           ;;
36   esac
37   if [ "`uname`" = Darwin ]; then
38     SO_FLAGS="-bundle"
39     if run_sbcl --eval '(sb-ext:quit :unix-status #+x86-64 0 #-x86-64 1)'; then
40         CFLAGS="$CFLAGS -arch x86_64"
41     fi
42   else
43     SO_FLAGS="-shared"
44   fi
45   cc -c $1.c -o $1.o $CFLAGS
46   ld $SO_FLAGS -o $1.so $1.o  
47 )
48
49 # We want to bail out in case any of these Unix programs fails.
50 set -e
51
52 cat > $TEST_FILESTEM.c <<EOF
53 int summish(int x, int y) { return 1 + x + y; }
54
55 int numberish = 42;
56
57 int nummish(int x) { return numberish + x; }
58
59 short negative_short() { return -1; }
60 int negative_int()     { return -2; }
61 long negative_long()   { return -3; }
62
63 long long powish(unsigned int x, unsigned int y) {
64   long long acc = 1;
65   long long xx = (long long) x;
66   for(; y != 1; y /= 2) {
67     if (y & 1) {
68       acc *= xx;
69       y -= 1;
70     }
71     xx *= xx;
72   }
73   return xx*acc;
74 }
75
76 float return9th(float f1, float f2, float f3, float f4, float f5, 
77                 float f6, float f7, float f8, float f9, float f10, 
78                 float f11, float f12) { 
79     return f9; 
80 }
81
82 double return9thd(double f1, double f2, double f3, double f4, double f5, 
83                   double f6, double f7, double f8, double f9, double f10,
84                   double f11, double f12) { 
85     return f9; 
86 }
87
88 int long_test8(int a1, int a2, int a3, int a4, int a5, 
89                int a6, int a7, long long l1) { 
90     return (l1 == powish(2,34));
91 }
92
93 int long_test9(int a1, int a2, int a3, int a4, int a5, 
94                int a6, int a7, long long l1, int a8) { 
95     return (l1 == powish(2,35));
96 }
97
98 int long_test2(int i1, int i2, int i3, int i4, int i5, int i6,
99                int i7, int i8, int i9, long long l1, long long l2) {
100     return (l1 == (1 + powish(2,37)));
101 }
102
103 long long return_long_long() {
104     return powish(2,33);
105 }
106 EOF
107
108 build_so $TEST_FILESTEM
109
110 echo 'int foo = 13;' > $TEST_FILESTEM-b.c
111 echo 'int bar() { return 42; }' >> $TEST_FILESTEM-b.c
112 build_so $TEST_FILESTEM-b
113
114 echo 'int foo = 42;' > $TEST_FILESTEM-b2.c
115 echo 'int bar() { return 13; }' >> $TEST_FILESTEM-b2.c
116 build_so $TEST_FILESTEM-b2
117
118 echo 'int late_foo = 43;' > $TEST_FILESTEM-c.c
119 echo 'int late_bar() { return 14; }' >> $TEST_FILESTEM-c.c
120 build_so $TEST_FILESTEM-c
121
122 ## Foreign definitions & load
123
124 cat > $TEST_FILESTEM.base.lisp <<EOF
125   (define-alien-variable environ (* c-string))
126   (defvar *environ* environ)
127   (eval-when (:compile-toplevel :load-toplevel :execute)
128     (handler-case
129         (progn
130           (load-shared-object (truename "$TEST_FILESTEM.so"))
131           (load-shared-object (truename "$TEST_FILESTEM-b.so")))
132       (sb-int:unsupported-operator ()
133         ;; At least as of sbcl-0.7.0.5, LOAD-SHARED-OBJECT isn't
134         ;; supported on every OS. In that case, there's nothing to test,
135         ;; and we can just fall through to success.
136         (sb-ext:quit :unix-status 22)))) ; catch that
137   (define-alien-routine summish int (x int) (y int))
138   (define-alien-variable numberish int)
139   (define-alien-routine nummish int (x int))
140   (define-alien-variable "foo" int)
141   (define-alien-routine "bar" int)
142
143   (define-alien-routine "negative_short" short)
144   (define-alien-routine "negative_int" int)
145   (define-alien-routine "negative_long" long)
146
147   (define-alien-routine return9th float (input1 float) (input2 float) (input3 float) (input4 float) (input5 float) (input6 float) (input7 float) (input8 float) (input9 float) (input10 float) (input11 float) (input12 float))
148   (define-alien-routine return9thd double (f1 double) (f2 double) (f3 double) (f4 double) (f5 double) (f6 double) (f7 double) (f8 double) (f9 double) (f10 double) (f11 double) (f12 double))
149
150   (define-alien-routine long-test8 int (int1 int) (int2 int) (int3 int) (int4 int) (int5 int) (int6 int) (int7 int) (long1 (integer 64)))
151   (define-alien-routine long-test9 int (int1 int) (int2 int) (int3 int) (int4 int) (int5 int) (int6 int) (int7 int) (long1 (integer 64)) (int8 int))
152   (define-alien-routine long-test2 int (int1 int) (int2 int) (int3 int) (int4 int) (int5 int) (int6 int) (int7 int) (int8 int) (int9 int) (long1 (integer 64)) (long2 (integer 64)))
153   (define-alien-routine return-long-long (integer 64))
154
155   ;; compiling this gets us the FOP-FOREIGN-DATAREF-FIXUP on
156   ;; linkage-table ports
157   (defvar *extern* (extern-alien "negative_short" short))
158
159   ;; Test that loading an object file didn't screw up our records
160   ;; of variables visible in runtime. (This was a bug until
161   ;; Nikodemus Siivola's patch in sbcl-0.8.5.50.)
162   ;;
163   ;; This cannot be tested in a saved core, as there is no guarantee
164   ;; that the location will be the same.
165   (assert (= (sb-sys:sap-int (alien-sap *environ*))
166              (sb-sys:sap-int (alien-sap environ))))
167
168   ;; automagic restarts
169   (setf *invoke-debugger-hook*
170         (lambda (condition hook)
171           (declare (ignore hook))
172           (princ condition)
173           (let ((cont (find-restart 'continue condition)))
174             (when cont
175               (invoke-restart cont)))
176           (print :fell-through)
177           (invoke-debugger condition)))
178 EOF
179
180 echo "(declaim (optimize speed))" > $TEST_FILESTEM.fast.lisp
181 cat $TEST_FILESTEM.base.lisp >> $TEST_FILESTEM.fast.lisp
182
183 echo "(declaim (optimize space))" > $TEST_FILESTEM.small.lisp
184 cat $TEST_FILESTEM.base.lisp >> $TEST_FILESTEM.small.lisp
185
186 # Test code
187 cat > $TEST_FILESTEM.test.lisp <<EOF
188   ;; FIXME: currently the start/small case fails on x86/Darwin. Moving
189   ;; this NOTE definition to the base.lisp file fixes that, but obviously
190   ;; it is better fo figure out what is going on instead of doing that...
191   ;;
192   ;; Other trivialish changes that mask the error include:
193   ;; * loading the .lisp file instead of the .fasl at the save test
194   ;; * --eval 'nil' before loading the .fasl at the save test
195   ;;
196   ;; HATE.
197   (defun note (x)
198      (write-line x *standard-output*)
199      (force-output *standard-output*))
200   (note "/initial assertions")
201   (assert (= 31 (summish 10 20)))
202   (assert (= 42 numberish))
203   (setf numberish 13)
204   (assert (= 13 numberish))
205   (assert (= 14 (nummish 1)))
206
207   (assert (= -1 (negative-short)))
208   (assert (= -2 (negative-int)))
209   (assert (= -3 (negative-long)))
210
211   (assert (= 9.0s0 (return9th 1.0s0 2.0s0 3.0s0 4.0s0 5.0s0 6.0s0 7.0s0 8.0s0 9.0s0 10.0s0 11.0s0 12.0s0)))
212   (assert (= 9.0d0 (return9thd 1.0d0 2.0d0 3.0d0 4.0d0 5.0d0 6.0d0 7.0d0 8.0d0 9.0d0 10.0d0 11.0d0 12.0d0)))
213
214   (assert (= 1 (long-test8 1 2 3 4 5 6 7 (ash 1 34))))
215   (assert (= 1 (long-test9 1 2 3 4 5 6 7 (ash 1 35) 8)))
216   (assert (= 1 (long-test2 1 2 3 4 5 6 7 8 9 (+ 1 (ash 1 37)) 15)))
217   (assert (= (ash 1 33) (return-long-long)))
218
219   (note "/initial assertions ok")
220
221   ;; test reloading object file with new definitions
222   (assert (= 13 foo))
223   (assert (= 42 (bar)))
224   (note "/original definitions ok")
225   (rename-file "$TEST_FILESTEM-b.so" "$TEST_FILESTEM-b.bak")
226   (rename-file "$TEST_FILESTEM-b2.so" "$TEST_FILESTEM-b.so")
227   (load-shared-object (truename "$TEST_FILESTEM-b.so"))
228   (note "/reloading ok")
229   (assert (= 42 foo))
230   (assert (= 13 (bar)))
231   (note "/redefined versions ok")
232   (rename-file "$TEST_FILESTEM-b.so" "$TEST_FILESTEM-b2.so")
233   (rename-file "$TEST_FILESTEM-b.bak" "$TEST_FILESTEM-b.so")
234   (note "/renamed back to originals")
235
236   ;; test late resolution
237   #+linkage-table
238   (progn
239     (note "/starting linkage table tests")
240     (define-alien-variable late-foo int)
241     (define-alien-routine late-bar int)
242     (multiple-value-bind (val err) (ignore-errors late-foo)
243       (assert (not val))
244       (assert (typep err 'undefined-alien-error)))
245     (multiple-value-bind (val err) (ignore-errors (late-bar))
246       (assert (not val))
247       (assert (typep err 'undefined-alien-error)))
248     (load-shared-object (truename "$TEST_FILESTEM-c.so"))
249     (assert (= 43 late-foo))
250     (assert (= 14 (late-bar)))
251     (unload-shared-object (truename "$TEST_FILESTEM-c.so"))
252     (multiple-value-bind (val err) (ignore-errors late-foo)
253       (assert (not val))
254       (assert (typep err 'undefined-alien-error)))
255     (multiple-value-bind (val err) (ignore-errors (late-bar))
256       (assert (not val))
257       (assert (typep err 'undefined-alien-error)))
258     (note "/linkage table ok"))
259
260   (sb-ext:quit :unix-status $EXIT_LISP_WIN) ; success convention for Lisp program
261 EOF
262
263 # Files are now set up; toggle errexit off, since we use a custom exit
264 # convention.
265 set +e
266
267 test_compile() {
268     run_sbcl <<EOF
269 (progn (load (compile-file "$TEST_FILESTEM.$1.lisp"))
270 (sb-ext:quit :unix-status $EXIT_LISP_WIN))
271 EOF
272     check_status_maybe_lose "compile $1" $?
273 }
274
275 test_compile fast
276 test_compile small
277
278 test_use() {
279     run_sbcl --load $TEST_FILESTEM.$1.fasl --load $TEST_FILESTEM.test.lisp
280     check_status_maybe_lose "use $1" $? 22 "(load-shared-object not supported)"
281 }
282
283 test_use small
284 test_use fast
285
286 test_save() {
287     echo testing save $1 
288     run_sbcl --load $TEST_FILESTEM.$1.fasl <<EOF
289 #+linkage-table (save-lisp-and-die "$TEST_FILESTEM.$1.core")
290 #-linkage-table nil
291 (sb-ext:quit :unix-status 22) ; catch this
292 EOF
293     check_status_maybe_lose "save $1" $? \
294         0 "(successful save)" 22 "(linkage table not available)"
295 }
296
297 test_save small
298 test_save fast
299
300 test_start() {
301     echo testing start $1
302     run_sbcl_with_core $TEST_FILESTEM.$1.core \
303         --no-sysinit --no-userinit --load $TEST_FILESTEM.test.lisp
304     check_status_maybe_lose "start $1" $?
305 }
306
307 test_start fast
308 test_start small
309
310 # missing object file
311 rm $TEST_FILESTEM-b.so $TEST_FILESTEM-b2.so
312 run_sbcl_with_core $TEST_FILESTEM.fast.core --no-sysinit --no-userinit <<EOF
313   (assert (= 22 (summish 10 11)))
314   (multiple-value-bind (val err) (ignore-errors (eval 'foo))
315     (assert (not val))
316     (assert (typep err 'undefined-alien-error)))
317   (multiple-value-bind (val err) (ignore-errors (eval '(bar)))
318     (assert (not val))
319     (assert (typep err 'undefined-alien-error)))
320   (quit :unix-status $EXIT_LISP_WIN)
321 EOF
322 check_status_maybe_lose "missing-so" $?
323
324 # ADDR of a heap-allocated object
325 cat > $TEST_FILESTEM.addr.heap.c <<EOF
326   struct foo
327   {
328     int x, y;
329   } a, *b;
330 EOF
331
332 build_so $TEST_FILESTEM.addr.heap
333
334 run_sbcl <<EOF
335   (load-shared-object (truename "$TEST_FILESTEM.addr.heap.so"))
336   (define-alien-type foo (struct foo (x int) (y int)))
337
338   (define-alien-variable a foo)
339   (define-alien-variable b (* foo))
340   (funcall (compile nil '(lambda () (setq b (addr a)))))
341   (assert (sb-sys:sap= (alien-sap a) (alien-sap (deref b))))
342   (quit :unix-status $EXIT_LISP_WIN)
343 EOF
344 check_status_maybe_lose "ADDR of a heap-allocated object" $?
345
346
347 # success convention for script
348 exit $EXIT_TEST_WIN